<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'DibPillar3',
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
});
</script>

<template>
  <SlpContainer>
    <SlpTypography variant="heading1-bold" tag="h2" class="slp-mb-16">
      {{ data.header }}
    </SlpTypography>
    <SlpTypography variant="heading5" tag="div" class="slp-mb-64">
      <div v-html="$md.render(data.text)" />
    </SlpTypography>
    <SlpRow class="cards">
      <template v-for="card in data.cards">
        <template v-if="card.cta">
          <SlpColumn
            v-if="card.cta"
            :key="card.title || card.text"
            :cols="card.quote ? 8 : 4"
            :class="{
              'quote-card-container': card.quote,
              'card-container': !card.quote,
            }"
          >
            <a
              :href="card.cta.href"
              :data-ga-name="card.cta.data_ga_name"
              :data-ga-location="card.cta.data_ga_location"
              class="card link"
            >
              <div class="card-content">
                <div class="card-text">
                  <SlpTypography
                    variant="heading5-bold"
                    tag="h3"
                    class="slp-mb-24"
                  >
                    {{ card.title }}
                  </SlpTypography>
                  <SlpTypography variant="body1" tag="div" class="slp-mb-24">
                    <div class="card__text" v-html="$md.render(card.text)" />
                  </SlpTypography>
                </div>
                <div class="card-cta">
                  <span>{{ card.cta.text }}</span>
                  <SlpIcon
                    class="learn-more-icon"
                    name="chevron-lg-right"
                    variant="product"
                  />
                </div>
              </div>
            </a>
          </SlpColumn>
        </template>
        <template v-else-if="!card.cta && !card.quote">
          <SlpColumn
            v-if="!card.cta && !card.quote"
            :key="card.title || card.text"
            :cols="4"
            class="card-container"
          >
            <div class="card">
              <div class="card-content">
                <SlpTypography
                  variant="heading5-bold"
                  tag="h3"
                  class="slp-mb-24"
                >
                  {{ card.title }}
                </SlpTypography>
                <SlpTypography variant="body1" tag="div" class="slp-mb-24">
                  <div class="card__text" v-html="$md.render(card.text)" />
                </SlpTypography>
              </div>
            </div>
          </SlpColumn>
        </template>
        <template v-else>
          <SlpColumn
            v-if="card.quote"
            :key="card.title || card.text"
            :cols="8"
            class="quote-card-container"
          >
            <div class="quote-card">
              <div class="card-content">
                <div class="quote-icon">
                  <SlpIcon
                    name="quote"
                    variant="marketing"
                    size="md"
                    class="quote-icon"
                  />
                </div>

                <SlpTypography variant="quotes" tag="p">
                  {{ card.text }}
                </SlpTypography>
                <div class="slp-mt-16 quote-author">
                  <div>
                    <img :src="card.img_src" alt="" />
                  </div>
                  <div>
                    <SlpTypography variant="body2-bold" tag="p">
                      {{ card.name }}
                    </SlpTypography>
                    <SlpTypography variant="body2" tag="p">
                      {{ card.title }}
                    </SlpTypography>
                  </div>
                </div>
              </div>
            </div>
          </SlpColumn>
        </template>
      </template>
    </SlpRow>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.cards {
  align-items: stretch;

  .card-container,
  .quote-card-container {
    padding: 16px;
    display: flex;
    flex-direction: column;
    flex-grow: 1;
  }

  .card-content {
    display: flex;
    flex-direction: column;
    flex-grow: 1;
  }

  .card {
    border-radius: 8px;
    background: #f6f3fe;
    padding: 32px;
    display: flex;
    flex-direction: column;
    flex-grow: 1;
    color: $color-text-300;
    transition: all 0.2s ease-in-out;

    &.link .slp-icon {
      transition: all 0.2s ease-in-out;
    }

    &.link:hover {
      border-radius: 8px 8px 100px 8px;

      .slp-icon {
        transform: translateX(8px);
      }

      .card-cta {
        text-decoration-color: $color-text-300;

        transition: all 0.2s ease-in-out;
      }
    }

    &__text {
      color: $color-text-200;

      &:deep ul {
        list-style: disc;
        padding-left: 1.5em;
      }
    }
  }

  .card-cta {
    box-sizing: border-box;
    font-family: 'GitLab Sans' 'sans-serif';
    min-width: 68px;
    display: inline-flex;
    align-items: center;
    text-align: center;
    vertical-align: middle;
    padding: 11px 16px;
    -webkit-text-decoration: none;
    text-decoration: underline;
    text-underline-offset: 4px;
    text-decoration-color: transparent;
    border-radius: 4px;
    font-weight: 600;
    font-size: 18px;
    line-height: 20px;
    color: #171321;
    border: none;
    padding-left: 0;
    transition: all 0.2s ease-in-out;
    margin-top: auto;
  }

  .cta-link {
    display: flex;
    align-items: center;
    text-decoration: none;
    color: inherit;
  }

  .quote-card {
    flex-grow: 1;
    padding: 48px;
    height: 100%;
    background: $color-surface-50;
    border: 1px solid;
    border-radius: 8px 8px 100px 8px;
    background-clip: padding-box;
    border: 1px solid transparent;
    position: relative;
    box-sizing: border-box;

    @media (max-width: $breakpoint-md) {
      padding: 48px 24px;
    }

    &:before {
      content: '';
      position: absolute;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      z-index: -1;
      margin: -1px;
      border-radius: inherit;
      background: linear-gradient(
        93.78deg,
        rgba(227, 153, 93, 0.5) 8.53%,
        rgba(203, 146, 150, 0.5) 14.9%,
        rgba(127, 72, 214, 0.5) 95.91%
      );
    }

    .quote-icon {
      display: block;
      margin-bottom: 16px;
    }

    .quote-author {
      margin-top: 32px;
      display: flex;
      gap: 32px;
      flex-direction: row;
      flex-wrap: nowrap;
      align-items: center;
      img {
        max-width: 120px;
        height: auto;
      }

      @media (max-width: $breakpoint-md) {
        flex-wrap: wrap;
      }
    }
  }
}
</style>
